From 76b441c1c491baad99013fe5ad527deffd3e77e9 Mon Sep 17 00:00:00 2001
From: Stephen Wang <wstephen@codeaurora.org>
Date: Wed, 13 May 2015 13:07:41 -0700
Subject: [PATCH] [nss-drv] Add a new failure return type if feature is not
 enabled

For enterprise profile, nss redirect is not enabled. Add a new
TX_FAILURE type to indicate the failure is due to feature not
enabled

Change-Id: Iddca1a00ee3989991dda1edfe7240539f229d9dc
Signed-off-by: Stephen Wang <wstephen@codeaurora.org>
---
 exports/nss_cmn.h   | 1 +
 nss_tx_rx_virt_if.c | 6 +++++-
 nss_virt_if.c       | 6 +++++-
 3 files changed, 11 insertions(+), 2 deletions(-)

diff --git a/exports/nss_cmn.h b/exports/nss_cmn.h
index 6c750d7..a8c63f0 100644
--- a/exports/nss_cmn.h
+++ b/exports/nss_cmn.h
@@ -40,6 +40,7 @@ typedef enum {
 	NSS_TX_FAILURE_TOO_SHORT,	/**< Command/Packet is shorter than expected size */
 	NSS_TX_FAILURE_NOT_SUPPORTED,	/**< Command/Packet not accepted for forwarding */
 	NSS_TX_FAILURE_BAD_PARAM,	/**< Command failure due to bad parameters */
+	NSS_TX_FAILURE_NOT_ENABLED,	/**< Command failure due to NSS feature is not enabled */
 } nss_tx_status_t;
 
 /**
diff --git a/nss_tx_rx_virt_if.c b/nss_tx_rx_virt_if.c
index 68ad80d..3779fa2 100644
--- a/nss_tx_rx_virt_if.c
+++ b/nss_tx_rx_virt_if.c
@@ -71,7 +71,11 @@ nss_tx_status_t nss_tx_virt_if_recvbuf(void *ctx, struct sk_buff *os_buf, uint32
 	uint32_t bufftype;
 	int32_t push_mac_header = 0;
 
-	if (unlikely(nss_ctl_redirect == 0) || unlikely(os_buf->vlan_tci)) {
+	if (unlikely(nss_ctl_redirect == 0)) {
+		return NSS_TX_FAILURE_NOT_ENABLED;
+	}
+
+	if (unlikely(os_buf->vlan_tci)) {
 		return NSS_TX_FAILURE_NOT_SUPPORTED;
 	}
 
diff --git a/nss_virt_if.c b/nss_virt_if.c
index a421463..fa11efb 100644
--- a/nss_virt_if.c
+++ b/nss_virt_if.c
@@ -93,7 +93,11 @@ nss_tx_status_t nss_virt_if_tx_rxbuf(struct nss_ctx_instance *nss_ctx, int32_t i
 {
 	int32_t status;
 
-	if (unlikely(nss_ctl_redirect == 0) || unlikely(skb->vlan_tci)) {
+	if (unlikely(nss_ctl_redirect == 0)) {
+		return NSS_TX_FAILURE_NOT_ENABLED;
+	}
+
+	if (unlikely(skb->vlan_tci)) {
 		return NSS_TX_FAILURE_NOT_SUPPORTED;
 	}
 
-- 
1.8.2

